IncludeScript(projectDir+"/_charlib/weapons.nut")
IncludeScript(projectDir+"/_charlib/weapon_models.nut")
IncludeScript(projectDir+"/_charlib/custom_voice.nut")

characterSettings <- {};
startingClass <- self.GetPlayerClass();

function ConvertToCharacterInternal()
{
    local playerClass = safeget(characterSettings, "playerClass", null);
    if (playerClass)
        self.SetPlayerClass(playerClass);
    self.Regenerate(true);
}
OnSelfEvent("post_inventory_application", -19, function(params)
{
    //We changed class
    //todo can a timer tick sneak in?
    if (safeget(characterSettings, "cleanOnClassChange", false) && self.GetPlayerClass() != startingClass)
    {
        ClearCustomCharacterInternal(true);
        return 117115;
    }

    local playerClass = safeget(characterSettings, "playerClass", null);
    if (playerClass)
    {
        self.RespawnFix();
        self.SetPlayerClass(playerClass);
        self.Regenerate(true);
    }

    if (safeget(characterSettings, "deleteItems", false))
        foreach(item in self.GetAttachments())
            item.Kill();
});

OnSelfEvent("post_inventory_application_post", -18, function(params)
{
    self.SetCustomModelWithClassAnimations(safeget(characterSettings, "model", null));
    self.SetModelScale(safeget(characterSettings, "scale", 1), 0);

    if (safeget(characterSettings, "mute", false))
        self.AddCustomAttribute("voice pitch scale", 0, -1);

    FireCustomEvent("init_custom_character", params);
});

function RefreshCharacter(keepCurrentHP = true)
{
}

function ClearCustomCharacterInternal(respawn = false)
{
    try
    {
        FireCustomEvent("clear_custom_character", {
        	userid = self.GetUserID()
        });
    }
    catch(e) { }
    foreach(item in self.GetAttachments())
    {
        if (item.GetClassname() != "tf_weapon_invis") //why is this like this?
            item.Kill();
    }
    self.SetCustomModelWithClassAnimations("");

    if (respawn)
        RunWithDelay(0.01, function(player) {
            if (IsValidPlayer(player))
            {
                player.ForceRegenerateAndRespawn();
                player.SetHealth(player.GetMaxHealth());
            }
        }, self, main_script);

    self.TerminateScriptScope();
}

OnSelfEvent("player_death", 0, function()
{
    RunWithDelay(0.1, function()
    {
        if (safeget(characterSettings, "cleanOnDeath", false))
            ClearCustomCharacterInternal();
    });
});

OnSelfEvent("player_disconnect", 0, ClearCustomCharacterInternal);
OnSelfEvent("player_team", 0, ClearCustomCharacterInternal);
OnGameEvent("scorestats_accumulated_update", 0, ClearCustomCharacterInternal);